/* IMa   for IM_analytic    2007-2009  Jody Hey and Rasmus Nielsen*/ 
/* December 17, 2009 */


#undef GLOBVARS
#include "ima.h"

/******** LOCAL STUFF ***********/
double pijt( int ci, int li, double mutrate, double t, double kappa, int from, int to);
int makefrac(int ci, int li, int node, double mutrate, double kappa, int e1, int e2, int e3, int e4);
double getstandfactor( int ci, int li, double kappa);


double pijt( int ci, int li, double mutrate, double t, double kappa, int from, int to)
    {   
    double A, PIj;

    if  (to==0 || to==2) PIj=C[ci]->L[li].pi[0]+C[ci]->L[li].pi[2];
    else PIj=C[ci]->L[li].pi[1]+C[ci]->L[li].pi[3];
    /*A=kappa+1.0; */ /*F84*/
    A=1.0+PIj*(kappa-1.0); /*HKY85*/
    if (from==to)
            return C[ci]->L[li].pi[to]+C[ci]->L[li].pi[to]*exp(-mutrate*t)*(1.0/PIj-1.0)+exp(-mutrate*t*A)*((PIj-C[ci]->L[li].pi[to])/PIj);
    else if (from+to==2 || from+to==4)
            return C[ci]->L[li].pi[to]+C[ci]->L[li].pi[to]*(1.0/PIj-1.0)*exp(-mutrate*t)-(C[ci]->L[li].pi[to]/PIj)*exp(-mutrate*t*A);
    else return C[ci]->L[li].pi[to]*(1.0-exp(-mutrate*t));
    }

// Jim Long's unwrapped makefrac() 
int makefrac(int ci, int li, int node, double mutrate, double kappa, int e1, int e2, int e3, int e4)
	{
	int i, j, up1, up2, ret = 0;
	double **fracpoint1, **fracpoint2;

	/* variables to precompute values */
	int stmp[2];
	double expp[2], kpa=kappa-1.0, A_j[2], L_to[4], PI_j[2], sum[4], temp[4];
	double minus_t_mutrate1, minus_t_mutrate2, exp1[2], exp2[2], onem[2];
	double A[2], PIj[2], divm[2], mdiv[2], pijt1, pijt2, ptmp[4], *pi  = C[ci]->L[li].pi;
	struct edge *tree = C[ci]->L[li].tree;
	double max;

	if (node == e1 || node == e2 || node == e3 || node == e4 || e1 == -1)
	ret = 1;

	up1 = tree[node].up[0];

	if (up1 != -1)
		{
		up2 = tree[node].up[1];
		i = makefrac (ci, li, up1,mutrate, kappa, e1, e2, e3, e4);
		if (i == 0)
		  fracpoint1 = tree[up1].hkyi.frac;
		else
			{
			fracpoint1 = tree[up1].hkyi.newfrac;
			ret = 1;
			}
		i = makefrac (ci, li, up2,mutrate, kappa, e1, e2, e3, e4);
		if (i == 0)
			fracpoint2 = tree[up2].hkyi.frac;
		else
			{
			fracpoint2 = tree[up2].hkyi.newfrac;
			ret = 1;
			}

		if (ret > 0)
			{
			if (tree[up1].up[0]== -1 && tree[up2].up[0]== -1)
				{
				minus_t_mutrate1 = -mutrate * tree[up1].time;
				minus_t_mutrate2 = -mutrate * tree[up2].time;
				expp[0] = exp(minus_t_mutrate1);
				expp[1] = exp(minus_t_mutrate2);
				for (i = 0; i < C[ci]->L[li].numsites; i++)
					{
					stmp[0] = C[ci]->L[li].seq[up1][i];
					stmp[1] = C[ci]->L[li].seq[up2][i];
					L_to[0] = pi[stmp[0]];
					L_to[1] = pi[stmp[1]];
					if(stmp[0] == 0 || stmp[0] == 2) PIj[0] = pi[0] + pi[2];
					else  PIj[0] = pi[1] + pi[3];
					if(stmp[1] == 0 || stmp[1] == 2) PIj[1] = pi[0] + pi[2];
					else  PIj[1] = pi[1] + pi[3];
					A[0] = 1.0 + PIj[0] * kpa;
					divm[0] = 1.0 / PIj[0] - 1.0;
					mdiv[0] = (PIj[0] - L_to[0]) / PIj[0];
					A[1] = 1.0 + PIj[1] * kpa;
					divm[1] = 1.0 / PIj[1] - 1.0;
					mdiv[1] = (PIj[1] - L_to[1]) / PIj[1];
					max=0.0;
					for(j=0; j<4; j++)
						{
						if(stmp[0] == j)
						  pijt1 = L_to[0] + L_to[0] * expp[0] * divm[0] +
							  exp(minus_t_mutrate1*A[0])  * mdiv[0];
						else if(stmp[0] + j == 2 || stmp[0] + j == 4)
						  pijt1 = L_to[0] + L_to[0] * expp[0] * divm[0] -
							 (L_to[0] / PIj[0]) * exp(minus_t_mutrate1*A[0]);
						else
						  pijt1 = L_to[0] * (1.0 - expp[0]);
    
						if(stmp[1] == j)
						  pijt2 = L_to[1] + L_to[1] * expp[1] * divm[1] +
							  exp(minus_t_mutrate2*A[1])  * mdiv[1];
						else if(stmp[1] + j == 2 || stmp[1] + j == 4)
						  pijt2 = L_to[1] + L_to[1] * expp[1] * divm[1] -
							 (L_to[1] / PIj[1]) * exp(minus_t_mutrate2*A[1]);
						else
						  pijt2 = L_to[1] * (1.0 - expp[1]);
    
						tree[node].hkyi.newfrac[i][j] = pijt1 * pijt2;
						if (tree[node].hkyi.newfrac[i][j]>max) max=tree[node].hkyi.newfrac[i][j];
						}
					for (j=0; j<4; j++)
					   tree[node].hkyi.newfrac[i][j]=tree[node].hkyi.newfrac[i][j]/max;
					tree[node].hkyi.scalefactor[i]=log(max);
					}
				}
			else 
			  if (tree[up1].up[0] == -1)
				{
				minus_t_mutrate1 = -mutrate*(tree[up2].time-tree[tree[up2].up[0]].time);
				minus_t_mutrate2 = -mutrate* tree[up1].time;
				expp[0] = exp(minus_t_mutrate1);
				onem[0] = 1.0 - expp[0];
				expp[1] = exp(minus_t_mutrate2);

				PI_j[0] = pi[0] + pi[2];
				PI_j[1] = pi[1] + pi[3];
				A_j[0]  = 1.0 + PI_j[0] * kpa;
				A_j[1]  = 1.0 + PI_j[1] * kpa;
				divm[0] = 1.0 / PI_j[0] - 1.0;
				divm[1] = 1.0 / PI_j[1] - 1.0;
				exp1[0] = exp(minus_t_mutrate1*A_j[0]);
				exp1[1] = exp(minus_t_mutrate1*A_j[1]);
				exp2[0] = exp(minus_t_mutrate2*A_j[0]);
				exp2[1] = exp(minus_t_mutrate2*A_j[1]);

				for (i = 0; i < C[ci]->L[li].numsites; i++)
					{
					max = 0.0;
					tree[node].hkyi.newfrac[i][0] = 0;
					tree[node].hkyi.newfrac[i][1] = 0;
					tree[node].hkyi.newfrac[i][2] = 0;
					tree[node].hkyi.newfrac[i][3] = 0;
					stmp[0] = C[ci]->L[li].seq[up1][i];

					if(stmp[0] == 0 || stmp[0] == 2) /* use PI_j[0] & A_j[0] */
						{
						for(j=0; j<4; j++)
							{
							  if(stmp[0] == j)
							ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[0] +
								  exp2[0] * ((PI_j[0] - pi[stmp[0]])/PI_j[0]);
							  else if(stmp[0] + j == 2 || stmp[0] + j == 4)
							ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[0] -
								 (pi[stmp[0]]/PI_j[0]) * exp2[0];
							  else
							ptmp[j] = pi[stmp[0]] * (1.0 - expp[1]);
							}
						}
					else /* use PI_j[1] & A_j[1] */
						{
						for(j=0; j<4; j++)
							{
							  if(stmp[0] == j)
							ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[1] +
								  exp2[1] * ((PI_j[1] - pi[stmp[0]])/PI_j[1]);
							  else if(stmp[0] + j == 2 || stmp[0] + j == 4)
							ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[1] -
								 (pi[stmp[0]]/PI_j[1]) * exp2[1];
							  else
							ptmp[j] = pi[stmp[0]] * (1.0 - expp[1]);
							}
						}
					temp[0] = (pi[0] + pi[0] * expp[0] * divm[0] + exp1[0] *
					   ((PI_j[0] - pi[0]) / PI_j[0])) * fracpoint2[i][0];
					myassert(fracpoint2 != 0x00000000);
						
					temp[1] = (pi[1] * onem[0]) * fracpoint2[i][1];
					temp[2] = (pi[2] + pi[2] * expp[0] * divm[0] - exp1[0] *
						(pi[2] / PI_j[0])) * fracpoint2[i][2];
					temp[3] = (pi[3] * onem[0]) * fracpoint2[i][3];
					tree[node].hkyi.newfrac[i][0] += temp[0]+temp[1]+temp[2]+temp[3];
					tree[node].hkyi.newfrac[i][0] *= ptmp[0];


					temp[0] = (pi[0] * onem[0]) * fracpoint2[i][0];
					temp[1] = (pi[1] + pi[1] * expp[0] * divm[1] + exp1[1] *
						((PI_j[1] - pi[1]) / PI_j[1])) * fracpoint2[i][1];
					temp[2] = (pi[2] * onem[0]) * fracpoint2[i][2];
					temp[3] = (pi[3] + pi[3] * expp[0] * divm[1] - exp1[1] *
						(pi[3] / PI_j[1])) * fracpoint2[i][3];
					tree[node].hkyi.newfrac[i][1] += temp[0]+temp[1]+temp[2]+temp[3];
					tree[node].hkyi.newfrac[i][1] *= ptmp[1];


					temp[0] = (pi[0] + pi[0] * expp[0] * divm[0] - exp1[0] *
						(pi[0] / PI_j[0])) * fracpoint2[i][0];
					temp[1] = (pi[1] * onem[0]) * fracpoint2[i][1];
					temp[2] = (pi[2] + pi[2] * expp[0] * divm[0] + exp1[0] *
						((PI_j[0] - pi[2]) / PI_j[0])) * fracpoint2[i][2];
					temp[3] = (pi[3] * onem[0]) * fracpoint2[i][3];
					tree[node].hkyi.newfrac[i][2] += temp[0]+temp[1]+temp[2]+temp[3];
					tree[node].hkyi.newfrac[i][2] *= ptmp[2];


					temp[0] = (pi[0] * onem[0]) * fracpoint2[i][0];
					temp[1] = (pi[1] + pi[1] * expp[0] * divm[1] - exp1[1] *
						(pi[1] / PI_j[1])) * fracpoint2[i][1];
					temp[2] = (pi[2] * onem[0]) * fracpoint2[i][2];
					temp[3] = (pi[3] + pi[3] * expp[0] * divm[1] + exp1[1] *
						((PI_j[1] - pi[3]) / PI_j[1])) * fracpoint2[i][3];
					tree[node].hkyi.newfrac[i][3] += temp[0]+temp[1]+temp[2]+temp[3];
					tree[node].hkyi.newfrac[i][3] *= ptmp[3];
					for(j=0; j<4; j++)
					if (tree[node].hkyi.newfrac[i][j]>max) max=tree[node].hkyi.newfrac[i][j];
					for (j=0; j<4; j++)
					tree[node].hkyi.newfrac[i][j]=tree[node].hkyi.newfrac[i][j]/max;
					tree[node].hkyi.scalefactor[i]=tree[up2].hkyi.scalefactor[i]+log(max);
					}
				}
			else 
				if (tree[up2].up[0] == -1)
					{
					minus_t_mutrate1 = -mutrate*(tree[up1].time-tree[tree[up1].up[0]].time);
					minus_t_mutrate2 = -mutrate* tree[up2].time;
					expp[0] = exp(minus_t_mutrate1);
					onem[0] = 1.0 - expp[0];
					expp[1] = exp(minus_t_mutrate2);

					PI_j[0] = pi[0] + pi[2];
					PI_j[1] = pi[1] + pi[3];
					A_j[0]  = 1.0 + PI_j[0] * kpa;
					A_j[1]  = 1.0 + PI_j[1] * kpa;
					divm[0] = 1.0 / PI_j[0] - 1.0;
					divm[1] = 1.0 / PI_j[1] - 1.0;
					exp1[0] = exp(minus_t_mutrate1*A_j[0]);
					exp1[1] = exp(minus_t_mutrate1*A_j[1]);
					exp2[0] = exp(minus_t_mutrate2*A_j[0]);
					exp2[1] = exp(minus_t_mutrate2*A_j[1]);

					for (i = 0; i < C[ci]->L[li].numsites; i++)
						{
						max = 0.0;
						tree[node].hkyi.newfrac[i][0] = 0;
						tree[node].hkyi.newfrac[i][1] = 0;
						tree[node].hkyi.newfrac[i][2] = 0;
						tree[node].hkyi.newfrac[i][3] = 0;

						stmp[0] = C[ci]->L[li].seq[up2][i];

						if(stmp[0] == 0 || stmp[0] == 2) /* use PI_j[0] & A_j[0] */
							{
							for(j=0; j<4; j++)
								{
								  if(stmp[0] == j)
								ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[0] +
									  exp2[0] * ((PI_j[0] - pi[stmp[0]])/PI_j[0]);
								  else if(stmp[0] + j == 2 || stmp[0] + j == 4)
								ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[0] -
									 (pi[stmp[0]]/PI_j[0]) * exp2[0];
								  else
								ptmp[j] = pi[stmp[0]] * (1.0 - expp[1]);
								}
							}
						else /* use PI_j[1] & A_j[1] */
							{
							for(j=0; j<4; j++)
								{
								  if(stmp[0] == j)
								ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[1] +
									  exp2[1] * ((PI_j[1] - pi[stmp[0]])/PI_j[1]);
								  else if(stmp[0] + j == 2 || stmp[0] + j == 4)
								ptmp[j] = pi[stmp[0]] + pi[stmp[0]] * expp[1] * divm[1] -
									 (pi[stmp[0]]/PI_j[1]) * exp2[1];
								  else
								ptmp[j] = pi[stmp[0]] * (1.0 - expp[1]);
								}
							}

						temp[0] = (pi[0] + pi[0] * expp[0] * divm[0] + exp1[0] *
							((PI_j[0] - pi[0]) / PI_j[0])) * fracpoint1[i][0];
						temp[1] = (pi[1] * onem[0]) * fracpoint1[i][1];
						temp[2] = (pi[2] + pi[2] * expp[0] * divm[0] - exp1[0] *
							(pi[2] / PI_j[0])) * fracpoint1[i][2];
						temp[3] = (pi[3] * onem[0]) * fracpoint1[i][3];
						tree[node].hkyi.newfrac[i][0] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][0] *= ptmp[0];


						temp[0] = (pi[0] * onem[0]) * fracpoint1[i][0];
						temp[1] = (pi[1] + pi[1] * expp[0] * divm[1] + exp1[1] *
							((PI_j[1] - pi[1]) / PI_j[1])) * fracpoint1[i][1];
						temp[2] = (pi[2] * onem[0]) * fracpoint1[i][2];
						temp[3] = (pi[3] + pi[3] * expp[0] * divm[1] - exp1[1] *
							(pi[3] / PI_j[1])) * fracpoint1[i][3];
						tree[node].hkyi.newfrac[i][1] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][1] *= ptmp[1];


						temp[0] = (pi[0] + pi[0] * expp[0] * divm[0] - exp1[0] *
							(pi[0] / PI_j[0])) * fracpoint1[i][0];
						temp[1] = (pi[1] * onem[0]) * fracpoint1[i][1];
						temp[2] = (pi[2] + pi[2] * expp[0] * divm[0] + exp1[0] *
							((PI_j[0] - pi[2]) / PI_j[0])) * fracpoint1[i][2];
						temp[3] = (pi[3] * onem[0]) * fracpoint1[i][3];
						tree[node].hkyi.newfrac[i][2] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][2] *= ptmp[2];


						temp[0] = (pi[0] * onem[0]) * fracpoint1[i][0];
						temp[1] = (pi[1] + pi[1] * expp[0] * divm[1] - exp1[1] *
							(pi[1] / PI_j[1])) * fracpoint1[i][1];
						temp[2] = (pi[2] * onem[0]) * fracpoint1[i][2];
						temp[3] = (pi[3] + pi[3] * expp[0] * divm[1] + exp1[1] *
							((PI_j[1] - pi[3]) / PI_j[1])) * fracpoint1[i][3];
						tree[node].hkyi.newfrac[i][3] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][3] *= ptmp[3];
						for (j=0; j<4; j++)
						if (tree[node].hkyi.newfrac[i][j]>max) max=tree[node].hkyi.newfrac[i][j];
						for (j=0; j<4; j++)
						tree[node].hkyi.newfrac[i][j]=tree[node].hkyi.newfrac[i][j]/max;
						tree[node].hkyi.scalefactor[i]=tree[up1].hkyi.scalefactor[i]+log(max);
						}
					}
				else
					{
					minus_t_mutrate1 = -mutrate*(tree[up1].time-tree[tree[up1].up[0]].time);
					minus_t_mutrate2 = -mutrate*(tree[up2].time-tree[tree[up2].up[0]].time);
					expp[0] = exp(minus_t_mutrate1);
					onem[0] = 1.0 - expp[0];
					expp[1] = exp(minus_t_mutrate2);
					onem[1] = 1.0 - expp[1];

					PI_j[0] = pi[0] + pi[2];
					PI_j[1] = pi[1] + pi[3];
					A_j[0]  = 1.0 + PI_j[0] * kpa;
					A_j[1]  = 1.0 + PI_j[1] * kpa;
					divm[0] = 1.0 / PI_j[0] - 1.0;
					divm[1] = 1.0 / PI_j[1] - 1.0;
					exp1[0] = exp(minus_t_mutrate1*A_j[0]);
					exp1[1] = exp(minus_t_mutrate1*A_j[1]);
					exp2[0] = exp(minus_t_mutrate2*A_j[0]);
					exp2[1] = exp(minus_t_mutrate2*A_j[1]);

					for (i = 0; i < C[ci]->L[li].numsites; i++)
						{
						max = 0.0;
						sum[0] = 0;
						sum[1] = 0;
						sum[2] = 0;
						sum[3] = 0;
						tree[node].hkyi.newfrac[i][0] = 0;
						tree[node].hkyi.newfrac[i][1] = 0;
						tree[node].hkyi.newfrac[i][2] = 0;
						tree[node].hkyi.newfrac[i][3] = 0;

						temp[0] = (pi[0] + pi[0] * expp[0] * divm[0] + exp1[0] *
							((PI_j[0] - pi[0]) /PI_j[0])) * fracpoint1[i][0];
						temp[1] = (pi[1] * onem[0]) * fracpoint1[i][1];
						temp[2] = (pi[2] + pi[2] * expp[0] * divm[0] - exp1[0] *
							(pi[2] / PI_j[0])) * fracpoint1[i][2];
						temp[3] = (pi[3] * onem[0]) * fracpoint1[i][3];
						sum[0] += temp[0]+temp[1]+temp[2]+temp[3];
    
						temp[0] = (pi[0] + pi[0] * expp[1] * divm[0] + exp2[0] *
							((PI_j[0] - pi[0]) / PI_j[0])) * fracpoint2[i][0];
						temp[1] = (pi[1] * onem[1]) * fracpoint2[i][1];
						temp[2] = (pi[2] + pi[2] * expp[1] * divm[0] - exp2[0] *
							(pi[2] / PI_j[0])) * fracpoint2[i][2];
						temp[3] = (pi[3] * onem[1]) * fracpoint2[i][3];
						tree[node].hkyi.newfrac[i][0] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][0] *= sum[0];


						temp[0] = (pi[0] * onem[0]) * fracpoint1[i][0];
						temp[1] = (pi[1] + pi[1] * expp[0] * divm[1] + exp1[1] *
							((PI_j[1] - pi[1]) /PI_j[1])) * fracpoint1[i][1];
						temp[2] = (pi[2] * onem[0]) * fracpoint1[i][2];
						temp[3] = (pi[3] + pi[3] * expp[0] * divm[1] - exp1[1] *
							(pi[3] / PI_j[1])) * fracpoint1[i][3];
						sum[1] += temp[0]+temp[1]+temp[2]+temp[3];
    
						temp[0] = (pi[0] * onem[1]) * fracpoint2[i][0];
						temp[1] = (pi[1] + pi[1] * expp[1] * divm[1] + exp2[1] *
							((PI_j[1] - pi[1]) / PI_j[1])) * fracpoint2[i][1];
						temp[2] = (pi[2] * onem[1]) * fracpoint2[i][2];
						temp[3] = (pi[3] + pi[3] * expp[1] * divm[1] - exp2[1] *
							(pi[3] / PI_j[1])) * fracpoint2[i][3];
						tree[node].hkyi.newfrac[i][1] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][1] *= sum[1];


						temp[0] = (pi[0] + pi[0] * expp[0] * divm[0] - exp1[0] *
							(pi[0] / PI_j[0])) * fracpoint1[i][0];
						temp[1] = (pi[1] * onem[0]) * fracpoint1[i][1];
						temp[2] = (pi[2] + pi[2] * expp[0] * divm[0] + exp1[0] *
							((PI_j[0] - pi[2]) / PI_j[0])) * fracpoint1[i][2];
						temp[3] = (pi[3] * onem[0]) * fracpoint1[i][3];
						sum[2] += temp[0]+temp[1]+temp[2]+temp[3];
    
						temp[0] = (pi[0] + pi[0] * expp[1] * divm[0] - exp2[0] *
							(pi[0] / PI_j[0])) * fracpoint2[i][0];
						temp[1] = (pi[1] * onem[1]) * fracpoint2[i][1];
						temp[2] = (pi[2] + pi[2] * expp[1] * divm[0] + exp2[0] *
							((PI_j[0] - pi[2]) /PI_j[0])) * fracpoint2[i][2];
						temp[3] = (pi[3] * onem[1]) * fracpoint2[i][3];
						tree[node].hkyi.newfrac[i][2] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][2] *= sum[2];


						temp[0] = (pi[0] * onem[0]) * fracpoint1[i][0];
						temp[1] = (pi[1] + pi[1] * expp[0] * divm[1] - exp1[1] *
							(pi[1] / PI_j[1])) * fracpoint1[i][1];
						temp[2] = (pi[2] * onem[0]) * fracpoint1[i][2];
						temp[3] = (pi[3] + pi[3] * expp[0] * divm[1] + exp1[1] *
							((PI_j[1] - pi[3]) /PI_j[1])) * fracpoint1[i][3];
						sum[3] += temp[0]+temp[1]+temp[2]+temp[3];
    
						temp[0] = (pi[0] * onem[1]) * fracpoint2[i][0];
						temp[1] = (pi[1] + pi[1] * expp[1] * divm[1] - exp2[1] *
							(pi[1] / PI_j[1])) * fracpoint2[i][1];
						temp[2] = (pi[2] * onem[1]) * fracpoint2[i][2];
						temp[3] = (pi[3] + pi[3] * expp[1] * divm[1] + exp2[1] *
							((PI_j[1] - pi[3]) /PI_j[1])) * fracpoint2[i][3];
						tree[node].hkyi.newfrac[i][3] += temp[0]+temp[1]+temp[2]+temp[3];
						tree[node].hkyi.newfrac[i][3] *= sum[3];
						for (j=0; j<4; j++)
						if (tree[node].hkyi.newfrac[i][j]>max) max=tree[node].hkyi.newfrac[i][j];
						for (j=0; j<4; j++)
							tree[node].hkyi.newfrac[i][j]=tree[node].hkyi.newfrac[i][j]/max;
						tree[node].hkyi.scalefactor[i]=tree[up1].hkyi.scalefactor[i]+tree[up2].hkyi.scalefactor[i]+log(max);
						}
					}
			}
		}
	return ret;
	}  // Jim Long's unwrapped makefrac() 

double getstandfactor( int ci, int li, double kappa)
    {
    int i, j;
    double p=0;

    for (i=0; i<4; i++){
        for (j=0; j<4; j++){
                if (i!=j){
                        if (i+j==2 || i+j==4)
                                p+=C[ci]->L[li].pi[i]*C[ci]->L[li].pi[j]*kappa;    /*HKY*/
                        else  p+=C[ci]->L[li].pi[i]*C[ci]->L[li].pi[j];
                        }
                }
        }
    return p;
    }


/************ GLOBAL FUNCTIONS ******************/


/* older version with recursion 
void labeltree( int ci, int li, int edge)
	{
	int dow1, sis;
	struct edge *tree = C[ci]->L[li].tree;

	dow1 = tree[edge].down;
	if (dow1 != -1)
		{
		
		if ((sis = tree[dow1].up[0]) == edge)
				sis = tree[dow1].up[1];
		if (tree[dow1].mut != tree[edge].mut)
			{
			if (tree[edge].mut == 2)
				{
				if (tree[sis].mut != -1)
					tree[dow1].mut = tree[sis].mut;
				else 
					tree[dow1].mut = 2;
				}
			else if ((tree[sis].mut != -1 && tree[sis].mut != 2) && (tree[sis].mut != tree[edge].mut))
				tree[dow1].mut = 2;
			else
				tree[dow1].mut = tree[edge].mut;
			labeltree(ci, li, dow1);
			}
		else if (tree[dow1].mut == 2)
			{
			if (tree[sis].mut != -1 && tree[sis].mut != 2)
				{
				tree[dow1].mut = tree[sis].mut;	
				labeltree(ci, li, dow1);
				}
			}
		}
	}	older version labeltree */

/* version without recursion, suggested by Jim Long as it allows inlining of the function */
__forceinline void labeltree(int ci, int li, int edge)
	{
	int dow1, sis, flag;
	struct edge *tree = C[ci]->L[li].tree;

	flag = 1;
	while(flag)
		{
		flag = 0;
		dow1 = tree[edge].down;
		if(dow1 == -1) break;

		if ((sis = tree[dow1].up[0]) == edge) sis = tree[dow1].up[1];

		if (tree[dow1].mut != tree[edge].mut)
			{
			  if (tree[edge].mut == 2)
			  {
				if (tree[sis].mut != -1) tree[dow1].mut = tree[sis].mut;
				else tree[dow1].mut = 2;
			  }
			  else if ((tree[sis].mut != -1 && tree[sis].mut != 2)
					&& (tree[sis].mut != tree[edge].mut))
				tree[dow1].mut = 2;
			  else
				tree[dow1].mut = tree[edge].mut;
			  flag = 1;
			}
		else if (tree[dow1].mut == 2)
			{
			  if (tree[sis].mut != -1 && tree[sis].mut != 2)
			  {
				tree[dow1].mut = tree[sis].mut;
				flag = 1;
			  }
			}
		edge = dow1;
		}
	} /* labeltree non-recursive */


double likelihoodHKY(int ci, int li, double mutrate, double kappa, int e1, int e2, int e3, int e4)
    {
    int i, j;
    double fracp, p=0;
	double temp;
	struct edge *tree = C[ci]->L[li].tree;
    if (modeloptions[RETURNPRIOR]) return 1;
    mutrate=mutrate/(C[ci]->L[li].totsites*getstandfactor(ci, li,kappa));
    for (i=C[ci]->L[li].numgenes; i<2*C[ci]->L[li].numgenes-1; i++)
            tree[i].hkyi.newfrac[0][0]=-1;
    makefrac(ci, li,C[ci]->L[li].root, mutrate, kappa, e1, e2, e3, e4);
    for (i=0; i<C[ci]->L[li].numsites; i++)
		{
            fracp=0;
            for (j=0; j<4; j++)
				{
				temp = tree[C[ci]->L[li].root].hkyi.newfrac[i][j];
                 fracp+=C[ci]->L[li].pi[j]*tree[C[ci]->L[li].root].hkyi.newfrac[i][j];
				}
			p+=C[ci]->L[li].mult[i]*(log(fracp)+tree[C[ci]->L[li].root].hkyi.scalefactor[i]);
    	}
    return p;
    }

void calc_sumlogk( int ci, int li, double *sumlogk)
/* basically a copy of the likelihood function, and probably overkill for what it does */
	{
	int ret, node, site, up1, up2, upup;
	double t;
	int summ = 0,*mutcount, i,j;
	double fact, sum;
	struct edge *tree = C[ci]->L[li].tree;
	int ng = C[ci]->L[li].numgenes;

    mutcount = calloc(ng,(sizeof(int *)));
	for (site=0; site<C[ci]->L[li].numsites; site++)
		{
		for (j=0; j<ng; j++)
			tree[j].mut = C[ci]->L[li].seq[j][site];
		for (j=ng; j<C[ci]->L[li].numlines; j++)
			tree[j].mut = -1;
		for (j=0; j<ng; j++)
			labeltree(ci, li, j);
		ret = -1;
		t = 0;
		for (node=ng; node<C[ci]->L[li].numlines; node++)
			{
			i = node - ng;
			up1 = tree[node].up[0];
			up2 = tree[node].up[1];
			if ((tree[up1].mut == 0 && tree[up2].mut == 1) || (tree[up1].mut== 1 && tree[up2].mut == 0))
				{
				if (node != ret && ret != -1)
					{
					return ;
					}
				else {
					if (tree[node].down == -1)
						{
						if ((upup = tree[up1].up[0]) == -1)
							t = tree[up1].time;
						else
							t = tree[up1].time-tree[upup].time;
						if ((upup = tree[up2].up[0]) == -1)
							t = t + tree[up2].time;
						else
							t = t + tree[up2].time-tree[upup].time;
						}
					else
						{
						if (tree[tree[node].down].mut == tree[up1].mut)
							{						
							if ((upup = tree[up2].up[0]) == -1)
							t = tree[up2].time;
								else
							t = tree[up2].time-tree[upup].time;
							}
						else
							{
							if ((upup = tree[up1].up[0]) == -1)
								t = tree[up1].time;
							else
								t = tree[up1].time-tree[upup].time;								
							}
						}
					ret = node;				
					mutcount[i]++;
					summ++;
					}
				}
			}
		if (ret == -1)
			{
			printf("error in site %i\n",site);
			err(ci, li,82);
			}
		}
	for (sum = 0.0,i=0; i< C[ci]->L[li].numlines - ng;i++)
		{
		fact = 1.0;
		for (j=1;j<=mutcount[i];j++)
			fact *= (double) j;
		sum += log(fact);
		}
	*sumlogk = sum;
    free(mutcount);
	}
	

double likelihoodIS( int ci, int li, double mutrate)
/* written by Rasmus to return the following value
 - (total length of tree in time) * theta + SUM(log(t_i * theta)*k_i, over all branches)
  where k_i is the number of mutations on branch i. 
  This is equal to the logarithm of the product of a bunch of poisson variables, one for each branch, except that 
  one term is dropped out. [ -SUM(log(k_i !)  ]  is not included.  However this will be the same for two infinite 
  sites trees that fit the same data set.
 */
 /* under new parameterization
 - (total length of tree in time) * mutrate + SUM(log(t_i * mutrate)*k_i, over all branches) - SUM(log(k_i !) 
  where k_i is the number of mutations on branch i. 
  as before, do not need to include  the term : -SUM(log(k_i !) 

  Can also do it as 
  - (total length of tree in time) * mutrate + log(mutrate) * SUM(k_i) + Sum(log(t_i)*k_i, over all branches) - SUM(log(k_i !) 
   check out the method of getting tree length - seems ok.
  */
	{
	int ret, j, node, site, up1, up2, upup;
	double time, p ;
	static  int done_sumlogk[MAXLOCI] = {0};
	static  double *sumlogk[MAXLOCI]; 
	int ng = C[ci]->L[li].numgenes;

    struct edge *tree;
	
    if (modeloptions[RETURNPRIOR]) return 1;
    if (done_sumlogk[li] == 0)
		{
		sumlogk[li] = calloc(1,sizeof(double));
		calc_sumlogk(ci, li,sumlogk[li]);
		done_sumlogk[li] = 1;
		}  
	p = - C[ci]->L[li].length  * mutrate;
	tree = C[ci]->L[li].tree;
	for (site=0; site < C[ci]->L[li].numsites; site++)
		{
		for (j=0; j<ng; j++)
			tree[j].mut = C[ci]->L[li].seq[j][site];
		for (j=ng; j<C[ci]->L[li].numlines; j++)
			tree[j].mut = -1;
		for (j=0; j<ng; j++)
			labeltree(ci, li, j);
		ret = -1;
		for (node=ng; node<C[ci]->L[li].numlines; node++)
			{
			up1 = tree[node].up[0];
			up2 = tree[node].up[1];
			if ((tree[up1].mut == 0 && tree[up2].mut == 1) || (tree[up1].mut== 1 && tree[up2].mut == 0))
				{
				if (node != ret && ret != -1)
					{
					return 0;
					}
				else {
                    /* i is the root node add together both branch times */
					if (tree[node].down == -1)
						{
						if ((upup = tree[up1].up[0]) == -1)
							time = tree[up1].time;
						else
							time = tree[up1].time-tree[upup].time;
						if ((upup = tree[up2].up[0]) == -1)
							time = time + tree[up2].time;
						else
							time = time + tree[up2].time-tree[upup].time;
						}
					else
                        /* i is not the root node  */
						{
						if (tree[tree[node].down].mut == tree[up1].mut)
							{						
							if ((upup = tree[up2].up[0]) == -1)
							time = tree[up2].time;
								else
							time = tree[up2].time-tree[upup].time;
							}
						else
							{
							if ((upup = tree[up1].up[0]) == -1)
								time = tree[up1].time;
							else
								time = tree[up1].time-tree[upup].time;								
							}
						}
					ret = node;				
					}
				}
			}
		if (ret == -1)
			{
			printf("error in site %i\n",site);
			err(ci, li,83);
			}
		else
			{
			p = p + log(time*mutrate);
			}
		}
	 p -= *sumlogk[li];  
	return p;
	}	/* likelihood */


/* likelihoodSW() calculates and  sums the dlikeA values on each branch */
/* if a locus is joint then ai goes from 0 to nlinked - 1  otherwise ai goes from 0 to nlinked */
double likelihoodSW(int ci, int li, int ai, double u, double tr)
    {
    int i, up, d; 
    double t, like;
	//int sumd;
	struct edge *tree = C[ci]->L[li].tree;
	//double sumd = 0;
	
    like = 0;
//	sumd = 0;
    for (i=0;i<2*C[ci]->L[li].numgenes-1;i++)
        {
        if (tree[i].down != -1)
            {
            d = tree[i].A[ai] - tree[tree[i].down].A[ai];
//sumd += abs(d);
            if (tree[i].up[0] == -1)
                t = tree[i].time*tr;
            else
                {
                up = tree[i].up[0];
                t = tr*(tree[i].time -  tree[up].time);
                }
            tree[i].dlikeA[ai] = -(t*u) + log(bessi(d,t*u));
            like += tree[i].dlikeA[ai];
            }
        else
            tree[i].dlikeA[ai] = 0.0;
        }
    if (modeloptions[RETURNPRIOR])
        return 1;
    else 
        return like;
    } /* likelihoodSW */

/* use this for debugging, to make sure likelihoodSW has set the dlikeA values properly */
void checklikelihoodSW(int ci, int li, int ai, double u)
    {
    int i, up, d; 
    double t, dlikeA;
	struct edge *tree = C[ci]->L[li].tree;

    for (i=0;i<2*C[ci]->L[li].numgenes-1;i++)
        {
        if (tree[i].down != -1)
            {
            d = tree[i].A[ai] - tree[tree[i].down].A[ai];
            if (tree[i].up[0] == -1)
                t = tree[i].time;
            else
                {
                up = tree[i].up[0];
                t = tree[i].time -  tree[up].time;
                }
            dlikeA = -(t*u) + log(bessi(d,t*u));
            if (tree[i].dlikeA[ai] != dlikeA)
                err(ci,li,91);
            }
        }
    } /* checklikelihoodSW */

